diff --git a/Applet/NDTConstants.java b/Applet/NDTConstants.java
index 6fb1c1c..7293b74 100644
--- a/Applet/NDTConstants.java
+++ b/Applet/NDTConstants.java
@@ -99,7 +99,24 @@ public class NDTConstants {
 
 	// Section: RFC 1323 options ( Seems like 0/1/2/3 are the options available)
 	
-	public static final int RFC_1323_DISABLED = 0;
+	// Not sure 0 is available maybe really old web100?
+	
+	public static final int RFC_1323_ENABLED = 1;
+	// Note Self disabled from servers standpoint i.e. disabled by server
+	public static final int RFC_1323_SELF_DISABLED = 2;
+	public static final int RFC_1323_PEER_DISABLED = 3;
+	
+	// Section: RFC2018 SAck
+	public static final int RFC_2018_ENABLED = 1;
+	
+	// Section: RFC2018 Nagle
+	public static final int RFC_896_ENABLED = 1;
+	
+	// Section: RFC3168
+	public static final int RFC_3168_ENABLED = 1;
+	// Note Self disabled from servers standpoint i.e. disabled by server
+	public static final int RFC_3168_SELF_DISABLED = 2;
+	public static final int RFC_3168_PEER_DISABLED = 3;
 	
 	// Section: Buffer limitation test thresholds
 	public static final float BUFFER_LIMITED = 0.15f; //unused right now
diff --git a/Applet/Tcpbw100.java b/Applet/Tcpbw100.java
index 54fbd25..93105a5 100644
--- a/Applet/Tcpbw100.java
+++ b/Applet/Tcpbw100.java
@@ -2746,7 +2746,12 @@ public class Tcpbw100 extends JApplet implements ActionListener {
 				_sEmailText += sSysvar + " " + sStrval + "\n%0A";
 				if (sStrval.indexOf(".") == -1) { // no decimal point, hence
 													// integer
-					iSysval = Integer.parseInt(sStrval);
+					try {
+						iSysval = Integer.parseInt(sStrval);
+					} catch (Exception e) {
+						System.out.println("Exception occured reading a tcp stat var - " + e);
+						iSysval = -1;
+					}
 					// save value into a key value expected by us
 					save_int_values(sSysvar, iSysval);
 				} else { // if not integer, save as double
@@ -3373,35 +3378,35 @@ public class Tcpbw100 extends JApplet implements ActionListener {
 			_txtStatistics.append("\n"
 					+ _resBundDisplayMsgs.getString("web100tcpOpts") + " \n");
 			_txtStatistics.append("RFC 2018 Selective Acknowledgment: ");
-			if (_iSACKEnabled == iZero)
-				_txtStatistics.append(_resBundDisplayMsgs.getString("off")
+			if (_iSACKEnabled == NDTConstants.RFC_2018_Enabled)
+				_txtStatistics.append(_resBundDisplayMsgs.getString("on")
 						+ "\n");
 			else
-				_txtStatistics.append(_resBundDisplayMsgs.getString("on")
+				_txtStatistics.append(_resBundDisplayMsgs.getString("off")
 						+ "\n");
 
 			_txtStatistics.append("RFC 896 Nagle Algorithm: ");
-			if (_iNagleEnabled == iZero)
-				_txtStatistics.append(_resBundDisplayMsgs.getString("off")
+			if (_iNagleEnabled == NDTConstants.RFC_896_ENABLED)
+				_txtStatistics.append(_resBundDisplayMsgs.getString("on")
 						+ "\n");
 			else
-				_txtStatistics.append(_resBundDisplayMsgs.getString("on")
+				_txtStatistics.append(_resBundDisplayMsgs.getString("off")
 						+ "\n");
 
 			_txtStatistics.append("RFC 3168 Explicit Congestion Notification: ");
-			if (_iECNEnabled == iZero)
-				_txtStatistics.append(_resBundDisplayMsgs.getString("off")
+			if (_iECNEnabled == NDTConstants.RFC_3168_ENABLED)
+				_txtStatistics.append(_resBundDisplayMsgs.getString("on")
 						+ "\n");
 			else
-				_txtStatistics.append(_resBundDisplayMsgs.getString("on")
+				_txtStatistics.append(_resBundDisplayMsgs.getString("off")
 						+ "\n");
 
 			_txtStatistics.append("RFC 1323 Time Stamping: ");
-			if (_iTimestampsEnabled == NDTConstants.RFC_1323_DISABLED)
-				_txtStatistics.append(_resBundDisplayMsgs.getString("off")
+			if (_iTimestampsEnabled == NDTConstants.RFC_1323_ENABLED)
+				_txtStatistics.append(_resBundDisplayMsgs.getString("on")
 						+ "\n");
 			else
-				_txtStatistics.append(_resBundDisplayMsgs.getString("on")
+				_txtStatistics.append(_resBundDisplayMsgs.getString("off")
 						+ "\n");
 
 			_txtStatistics.append("RFC 1323 Window Scaling: ");
@@ -3592,12 +3597,20 @@ public class Tcpbw100 extends JApplet implements ActionListener {
 
 		// get client side IP
 		String sClientSideClientIp = tokens.nextToken();
-		k = sClientSideServerIp.indexOf("/");
+		System.out.println("IP --" + sClientSideClientIp);
+		k = sClientSideClientIp.indexOf("/");
+		System.out.println("k is: " + k);
+		sClientSideClientIp = sClientSideClientIp.substring(k + 1);
+		System.out.println("IP --" + sClientSideClientIp);
+
 		sClientSideServerIp = sClientSideServerIp.substring(k + 1);
 
 		// MSS = 1456 = Ethernet MTU = 1500 - 24 -20 (bytes of IP header) =
 		// 1456, thus preserved
-		
+	
+		if (_iTimestampsEnabled == NDTConstants.RFC_1323_ENABLED)
+			iMss += 12;
+
 		if (iMss == NDTConstants.ETHERNET_MTU_SIZE)
 			_txtStatistics.append(_resBundDisplayMsgs
 					.getString("packetSizePreserved") + "\n");
diff --git a/WEB10G_README b/WEB10G_README
new file mode 100644
index 0000000..a6bcb41
--- /dev/null
+++ b/WEB10G_README
@@ -0,0 +1,19 @@
+Quick Build Notes
+Although you don't need a web10g kernel to build, if you wish to run the server you will.
+
+I've tested with linux 3.5.1 kernel patched with web10g (web10.org - 	Web10G-0.4-3.5-patch). I had to modify the patch - Swap ktime_to_ns(...) with ktime_to_us(...).
+
+You need to make and install the Web10G-userland library I used Web10G-userland-2.0.4.
+
+Configure and build ndt as normal. Web10G libs should be detected and hence the web10gsrv built. Web100 is still fully supported and if Web100 libs are found web100srv will be built.
+
+Known issues
+
+Web10G related
+* Logging functionality not yet implemented some related functions are missing.
+* Web10g patch not quite right - need to modify ktime_to_ns to ktime_to_us.
+* Server and Client(C and Java Applet) have been ported, other tools have not. Depending on their function they may not work.
+
+Other
+* Running the server without a DNS server can cause tests to timeout and fail. Add the NI_NUMERICHOST flag into the getnameinfo call within _I2AddrSetNodePort() in the I2Util library to fix.
+* MSS incorrectly detecting modification when testing via IPv6??
diff --git a/configure.ac b/configure.ac
index c4f6542..9074dd4 100644
--- a/configure.ac
+++ b/configure.ac
@@ -145,6 +145,18 @@ AC_CHECK_LIB([web100], [web100_snap],
                INCLUDED_WEB100LIB=""
                AM_CONDITIONAL(HAVE_WEB100, false)
                ])
+AC_CHECK_LIB([tcpe], [tcpe_client_init],
+             [
+              LINKED_TCPELIB="-ltcpe"
+              INCLUDED_TCPELIB="-I/usr/local/include/tcpe"
+              AC_DEFINE(HAVE_LIBTCPE, 1, [Define to 1 if you have the 'Web10G' library (-ltcpe).])
+              AM_CONDITIONAL(HAVE_TCPE, true)
+             ],
+             [
+              LINKED_TCPELIB=""
+              INCLUDED_TCPELIB=""
+              AM_CONDITIONAL(HAVE_TCPE, false)
+            ])
 
 AC_CHECK_LIB([pcap], [pcap_open_live],
              [
@@ -197,14 +209,16 @@ AC_CHECK_LIB([odbc], [SQLDriverConnect],
                ])
 
 
-NDTINCDIR='$(INCLUDED_WEB100LIB) $(INCLUDED_PCAPLIB)'
+NDTINCDIR='$(INCLUDED_WEB100LIB) $(INCLUDED_PCAPLIB) $(INCLUDED_TCPELIB)'
 NDTLIBDIR=/usr/local/lib
 NDTLDFLAGS='-L$(NDTLIBDIR) -Wl,-rpath,$(NDTLIBDIR)'
-NDTLIBS='$(LINKED_WEB100LIB) $(LINKED_PCAPLIB) $(LINKED_ODBCLIB) -lm'
+NDTLIBS='$(LINKED_WEB100LIB) $(LINKED_PCAPLIB) $(LINKED_ODBCLIB) $(LINKED_TCPELIB) -lm'
 NDTINCS='-I$(NDTINCDIR)'
 
 AC_SUBST(LINKED_WEB100LIB)
 AC_SUBST(INCLUDED_WEB100LIB)
+AC_SUBST(LINKED_TCPELIB)
+AC_SUBST(INCLUDED_TCPELIB)
 AC_SUBST(LINKED_PCAPLIB)
 AC_SUBST(INCLUDED_PCAPLIB)
 AC_SUBST(LINKED_ODBCLIB)
@@ -275,6 +289,12 @@ echo "***********************************"
 echo ""
 echo ""
 
+if test -z "$HAVE_TCPE_TRUE" && test -n "$HAVE_TCPE_FALSE"; then
+  SUMMARY_WEB10GSRV="YES"
+else
+  SUMMARY_WEB10GSRV="NO (missing tcpe (web10g) library)"
+fi
+
 SUMMARY_WEB100CLT="YES"
 if test -z "$HAVE_WEB100_TRUE" && test -n "$HAVE_WEB100_FALSE"; then
 if test -z "$HAVE_PCAP_H_TRUE" && test -n "$HAVE_PCAP_H_FALSE"; then
@@ -314,13 +334,14 @@ fi
 echo "* web100clt:    ${SUMMARY_WEB100CLT}"
 echo ""
 
-if test "$SUMMARY_FAKEWWW" = "YES" && test "$SUMMARY_WEB100SRV" = "YES" && test "$SUMMARY_TCPBW100JAR" = "YES"; then
+if test "$SUMMARY_FAKEWWW" = "YES" && (test "$SUMMARY_WEB100SRV" = "YES" || test "$SUMMARY_WEB100GSRV" = "YES") && test "$SUMMARY_TCPBW100JAR" = "YES"; then
 echo "*** Server Tools - complete"
 else
 echo "*** Server Tools - incomplete"
 fi
 echo "* fakewww:      ${SUMMARY_FAKEWWW}"
 echo "* web100srv:    ${SUMMARY_WEB100SRV}"
+echo "* web10gsrv:    ${SUMMARY_WEB10GSRV}"
 echo "* Tcpbw100.jar: ${SUMMARY_TCPBW100JAR}"
 echo ""
 
diff --git a/src/Makefile.am b/src/Makefile.am
index d9b5d3c..b022ebd 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -33,6 +33,16 @@ else
 bin_PROGRAMS = web100clt
 endif
 
+if HAVE_TCPE
+if HAVE_PCAP_H
+if HAVE_WEB100
+sbin_PROGRAMS += web10gsrv
+else
+sbin_PROGRAMS = fakewww web10gsrv
+endif
+endif
+endif
+
 web100clt_SOURCES = web100clt.c network.c usage.c logging.c utils.c protocol.c runningtest.c ndtptestconstants.c \
                     test_sfw_clt.c test_mid_clt.c test_c2s_clt.c test_s2c_clt.c test_meta_clt.c strlutils.c \
 			test_results_clt.c
@@ -46,7 +56,7 @@ genplot_CPPFLAGS ='-DBASEDIR="$(ndtdir)"'
 
 analyze_SOURCES = analyze.c usage.c logging.c runningtest.c ndtptestconstants.c strlutils.c
 analyze_LDADD = $(NDTLIBS) $(I2UTILLIBDEPS) $(ZLIB)
-analyze_CPPFLAGS ='-DBASEDIR="$(ndtdir)"'
+analyze_CPPFLAGS ='-DBASEDIR="$(ndtdir)"' -DFORCE_WEB100
 
 fakewww_SOURCES = fakewww.c troute.c troute6.c tr-tree.c tr-tree6.c network.c usage.c logging.c \
 	 runningtest.c ndtptestconstants.c strlutils.c
@@ -59,12 +69,21 @@ web100srv_SOURCES = web100srv.c web100-util.c web100-pcap.c web100-admin.c runni
 		    test_c2s_srv.c test_s2c_srv.c test_mid_srv.c
 web100srv_LDFLAGS = $(NDTLDFLAGS) $(I2UTILLDFLAGS)
 web100srv_LDADD = $(NDTLIBS) $(I2UTILLIBS) $(I2UTILLIBDEPS) -lpthread $(ZLIB)
-web100srv_CPPFLAGS ='-DBASEDIR="$(ndtdir)"'
+web100srv_CPPFLAGS ='-DBASEDIR="$(ndtdir)"' -DFORCE_WEB100
 web100srv_DEPENDENCIES = $(I2UTILLIBDEPS)
 
+web10gsrv_SOURCES = web100srv.c web100-util.c web100-pcap.c web100-admin.c runningtest.c \
+		    network.c usage.c utils.c mrange.c logging.c testoptions.c ndtptestconstants.c \
+		    protocol.c test_sfw_srv.c test_meta_srv.c ndt_odbc.c strlutils.c heuristics.c \
+		    test_c2s_srv.c test_s2c_srv.c test_mid_srv.c web10g-util.c
+web10gsrv_LDFLAGS = $(NDTLDFLAGS) $(I2UTILLDFLAGS)
+web10gsrv_LDADD = $(NDTLIBS) $(I2UTILLIBS) $(I2UTILLIBDEPS) -lpthread $(ZLIB)
+web10gsrv_CPPFLAGS = '-DBASEDIR="$(ndtdir)"'
+web10gsrv_DEPENDENCIES = $(I2UTILLIBDEPS)
+
 viewtrace_SOURCES = viewtrace.c usage.c logging.c utils.c runningtest.c ndtptestconstants.c strlutils.c
 viewtrace_LDADD = $(NDTLIBS) $(I2UTILLIBDEPS) $(ZLIB)
-viewtrace_CPPFLAGS ='-DBASEDIR="$(ndtdir)"'
+viewtrace_CPPFLAGS ='-DBASEDIR="$(ndtdir)"' -DFORCE_WEB100
 
 tr_mkmap_SOURCES = tr-mkmap.c tr-tree.c tr-tree6.c usage.c logging.c runningtest.c ndtptestconstants.c strlutils.c
 tr_mkmap_LDADD = $(NDTLIBS) $(I2UTILLIBDEPS) $(ZLIB)
diff --git a/src/logging.c b/src/logging.c
index 2689dd2..48afa08 100644
--- a/src/logging.c
+++ b/src/logging.c
@@ -701,7 +701,7 @@ void protolog_println(char *msgdirection, const int type, void* msg,
  * @param processid PID of process
  * @param ctlSocket socket over which message has been exchanged
  * */
-void protolog_sendprintln(const int type, void* msg, const int len,
+void protolog_sendprintln(const int type, const void* msg, const int len,
                           const int processid, const int ctlSocket) {
   char *currentDir;
 
@@ -711,7 +711,7 @@ void protolog_sendprintln(const int type, void* msg, const int len,
   }
   currentDir = get_currentdirndesc();
 
-  protolog_println(currentDir, type, msg, len, processid, ctlSocket);
+  protolog_println(currentDir, type, (void*) msg, len, processid, ctlSocket);
 }
 
 /**
diff --git a/src/logging.h b/src/logging.h
index 25af4f2..1c587b0 100644
--- a/src/logging.h
+++ b/src/logging.h
@@ -99,7 +99,7 @@ void log_linkspeed(int index);
 void protolog_printgeneric(const char* key, const char* val, int socketnum);
 void protolog_status(int pid, enum TEST_ID testid,
                      enum TEST_STATUS_INT teststatus, int socketnum);
-void protolog_sendprintln(const int type, void* msg, const int len,
+void protolog_sendprintln(const int type, const void* msg, const int len,
                           const int processid, const int ctlSocket);
 void protolog_rcvprintln(const int type, void* msg, const int len,
                          const int processid, const int ctlSocket);
diff --git a/src/network.c b/src/network.c
index 5a6eb08..cfc539c 100644
--- a/src/network.c
+++ b/src/network.c
@@ -415,7 +415,7 @@ int CreateConnectSocket(int* sockfd, I2Addr local_addr, I2Addr server_addr,
  *
  */
 
-int send_msg(int ctlSocket, int type, void* msg, int len) {
+int send_msg(int ctlSocket, int type, const void* msg, int len) {
   unsigned char buff[3];
   int rc, i;
 
@@ -524,9 +524,9 @@ int recv_msg(int ctlSocket, int* type, void* msg, int* len) {
  * @return The amount of bytes written to the file descriptor
  */
 
-int writen(int fd, void* buf, int amount) {
+int writen(int fd, const void* buf, int amount) {
   int sent, n;
-  char* ptr = buf;
+  const char* ptr = buf;
   sent = 0;
   assert(amount >= 0);
   while (sent < amount) {
diff --git a/src/network.h b/src/network.h
index fd0d2f6..2205986 100644
--- a/src/network.h
+++ b/src/network.h
@@ -20,9 +20,9 @@
 I2Addr CreateListenSocket(I2Addr addr, char* serv, int options, int buf_size);
 int CreateConnectSocket(int* sockfd, I2Addr local_addr, I2Addr server_addr,
                         int option, int buf_sizes);
-int send_msg(int ctlSocket, int type, void* msg, int len);
+int send_msg(int ctlSocket, int type, const void* msg, int len);
 int recv_msg(int ctlSocket, int* type, void* msg, int* len);
-int writen(int fd, void* buf, int amount);
+int writen(int fd, const void* buf, int amount);
 int readn(int fd, void* buf, int amount);
 
 /* web100-util.c routine used in network. */
diff --git a/src/test_c2s_srv.c b/src/test_c2s_srv.c
index b3a2103..60de92d 100644
--- a/src/test_c2s_srv.c
+++ b/src/test_c2s_srv.c
@@ -61,10 +61,13 @@ int mon_pipe1[2];
  *			-102 - Retries exceeded while waiting for data from connected client
  *
  */
-int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_c2s(int ctlsockfd, tcp_stat_agent* agent, TestOptions* testOptions,
              int conn_options, double* c2sspd, int set_buff, int window,
              int autotune, char* device, Options* options, int record_reverse,
              int count_vars, char spds[4][256], int* spd_index) {
+  tcp_stat_connection conn;
+  tcp_stat_group* group = NULL;
+
   int recvsfd;  // receiver socket file descriptor
   pid_t c2s_childpid = 0;  // child process pids
   int msgretvalue, tmpbytecount;  // used during the "read"/"write" process
@@ -85,14 +88,12 @@ int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
   char listenc2sport[10];  // listening port
   pthread_t workerThreadId;
 
-  // web_100 related variables
-  web100_group* group = NULL;
-  web100_connection* conn = NULL;
-
   // snap related variables
   SnapArgs snapArgs;
   snapArgs.snap = NULL;
+#if USE_WEB100
   snapArgs.log = NULL;
+#endif
   snapArgs.delay = options->snapDelay;
   wait_sig = 0;
 
@@ -252,8 +253,8 @@ int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
     // commenting out below to move to init_pkttrace function
     I2Addr src_addr = I2AddrByLocalSockFD(get_errhandle(), recvsfd, 0);
 
-    // Get web100 connection. Used to collect web100 variable statistics
-    conn = web100_connection_from_socket(agent, recvsfd);
+    // Get tcp_stat connection. Used to collect tcp_stat variable statistics
+    conn = tcp_stat_connection_from_socket(agent, recvsfd);
 
     // set up packet tracing. Collected data is used for bottleneck link
     // calculations
@@ -281,6 +282,7 @@ int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
                     &cli_addr);
         init_pkttrace(src_addr, (struct sockaddr *) &cli_addr, clilen,
                       mon_pipe1, device, &pair, "c2s", options->compress);
+        log_println(1, "c2s is exiting gracefully");
         exit(0); /* Packet trace finished, terminate gracefully */
       }
 
@@ -292,7 +294,7 @@ int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
           continue;
         break;
       }
-      if (strlen(tmpstr) > 5)
+      //if (strlen(tmpstr) > 5)
         memcpy(meta.c2s_ndttrace, tmpstr, strlen(tmpstr));
       // name of nettrace file passed back from pcap child
       log_println(3, "--tracefile after packet_trace %s",
@@ -375,13 +377,12 @@ int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
     // get receiver side Web100 stats and write them to the log file. close
     // sockets
     if (record_reverse == 1)
-      web100_get_data_recv(recvsfd, agent, conn, count_vars);
-
-    close(recvsfd);
-    close(testOptions->c2ssockfd);
+      tcp_stat_get_data_recv(recvsfd, agent, conn, count_vars);
 
     // Next, send speed-chk a flag to retrieve the data it collected.
     // Skip this step if speed-chk isn't running.
+    close(recvsfd);
+    close(testOptions->c2ssockfd);
 
     if (getuid() == 0) {
       log_println(1, "Signal USR1(%d) sent to child [%d]", SIGUSR1,
diff --git a/src/test_meta_srv.c b/src/test_meta_srv.c
index b22d1de..216f9bd 100644
--- a/src/test_meta_srv.c
+++ b/src/test_meta_srv.c
@@ -22,7 +22,7 @@
 /**
  * Performs the META test.
  * @param ctlsockfd Client control socket descriptor
- * @param agent Web100 agent used to track the connection
+ * @param agent UNUSED Web100 agent used to track the connection
  * @param testOptions The test options
  * @param conn_options The connection options
  * @return 0 - success,
@@ -38,7 +38,7 @@
  *			4 - Invalid data format in received message
  */
 
-int test_meta_srv(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_meta_srv(int ctlsockfd, tcp_stat_agent* agent, TestOptions* testOptions,
                   int conn_options) {
   int j;
   int msgLen, msgType;
diff --git a/src/test_mid_srv.c b/src/test_mid_srv.c
index 7172d94..367baf4 100644
--- a/src/test_mid_srv.c
+++ b/src/test_mid_srv.c
@@ -9,7 +9,7 @@
  *      Author: kkumar
  */
 
-#include  <syslog.h>
+#include <syslog.h>
 #include <pthread.h>
 #include <sys/times.h>
 #include <assert.h>
@@ -37,7 +37,7 @@
  *          >0 - error code.
  *          Error codes:
  * 				-1 - Listener socket creation failed
- *				-3 - web100 connection data not obtained
+ *				-3 - tcp_stat connection data not obtained
  *				-100 - timeout while waiting for client to connect to serverÕs ephemeral port
  *				-errno- Other specific socket error numbers
  *				-101 - Retries exceeded while waiting for client to connect
@@ -49,7 +49,7 @@
  *
  */
 
-int test_mid(int ctlsockfd, web100_agent* agent, TestOptions* options,
+int test_mid(int ctlsockfd, tcp_stat_agent* agent, TestOptions* options,
              int conn_options, double* s2c_throughput_mid) {
   int maxseg = ETHERNET_MTU_SIZE;
   /* int maxseg=1456, largewin=16*1024*1024; */
@@ -66,7 +66,7 @@ int test_mid(int ctlsockfd, web100_agent* agent, TestOptions* options,
   char listenmidport[10];  // listener socket for middlebox tests
   int msgType;
   int msgLen;
-  web100_connection* conn;
+  tcp_stat_connection conn;
   char tmpstr[256];  // temporary string storage
   struct timeval sel_tv;  // time
   fd_set rfd;  // receiver file descriptor
@@ -235,8 +235,9 @@ int test_mid(int ctlsockfd, web100_agent* agent, TestOptions* options,
     meta.family = ((struct sockaddr *) &cli_addr)->sa_family;
 
     buff[0] = '\0';
-    // get web100 connection data
-    if ((conn = web100_connection_from_socket(agent, midsfd)) == NULL) {
+    // get tcp_stat connection data
+#if USE_WEB100
+    if ((conn = tcp_stat_connection_from_socket(agent, midsfd)) == NULL) {
       log_println(
           0,
           "!!!!!!!!!!!  test_mid() failed to get web100 connection data, rc=%d",
@@ -244,9 +245,18 @@ int test_mid(int ctlsockfd, web100_agent* agent, TestOptions* options,
       /* exit(-1); */
       return -3;
     }
+#elif USE_TCPE
+    if ((conn = tcp_stat_connection_from_socket(agent, midsfd)) == -1) {
+      log_println(
+          0,
+          "test_min() failed to get web10g connection data, rc=%d",
+          errno);
+      return -3;
+    }
+#endif
 
     // Perform S->C throughput test. Obtained results in "buff"
-    web100_middlebox(midsfd, agent, conn, buff, sizeof(buff));
+    tcp_stat_middlebox(midsfd, agent, conn, buff, sizeof(buff));
 
     // Transmit results in the form of a TEST_MSG message
     send_msg(ctlsockfd, TEST_MSG, buff, strlen(buff));
diff --git a/src/test_results_clt.c b/src/test_results_clt.c
index a6aff54..345c1c0 100644
--- a/src/test_results_clt.c
+++ b/src/test_results_clt.c
@@ -296,15 +296,27 @@ void print_packetloss_excess(double spd, double loss) {
 
 /**
  * Print if TCP Selective Acknowledgment Options based on RFC 2018 is on
- *
+ * web100: 0 off, >=1 on.
+ * web10g: 1 on, 2 selfDisabled, 3 peerDisabled.
  * @param SACKEnabled
  */
 void print_SAck_RFC2018(int SACKEnabled) {
   printf("RFC 2018 Selective Acknowledgment: ");
+#if USE_TCPE
+  if (SACKEnabled == 1)
+    printf("ON\n");
+  else if (SACKEnabled == 2)
+    printf("OFF (self)\n");
+  else if (SACKEnabled == 3)
+    printf("OFF (peer)\n");
+  else
+    printf("<undefined (%d)>\n", SACKEnabled);
+#elif USE_WEB100
   if (SACKEnabled == 0)
     printf("OFF\n");
   else
     printf("ON\n");
+#endif
 }
 
 /**
@@ -314,35 +326,69 @@ void print_SAck_RFC2018(int SACKEnabled) {
 
 void print_Nagle_RFC896(int is_nagleenabled) {
   printf("RFC 896 Nagle Algorithm: ");
+#if USE_TCPE
+  if (is_nagleenabled == 1)
+    printf("ON\n");
+  else if (is_nagleenabled == 2)
+    printf("OFF\n");
+  else
+    printf("<undefined (%d)>\n", is_nagleenabled);
+#elif USE_WEB100
   if (is_nagleenabled == 0)
     printf("OFF\n");
   else
     printf("ON\n");
+#endif
 }
 
 /**
  * Print if Explicit congestion notification to IP is on - RFC 3168 related
+ * web100 0 off, >=1 on
+ * web10g 1 on, 2 selfDisabled, 3 peerDisabled
  * @param is_ECNenabled
  */
 void print_congestion_RFC3168(int is_ECNenabled) {
   printf("RFC 3168 Explicit Congestion Notification: ");
+#if USE_TCPE
+  if (is_ECNenabled == 1)
+    printf("ON\n");
+  else if (is_ECNenabled == 2)
+    printf("OFF (self)\n");
+  else if (is_ECNenabled == 3)
+    printf("OFF (peer)\n");
+  else
+    printf("<undefined (%d)>\n", is_ECNenabled);
+#elif USE_WEB100
   if (is_ECNenabled == 0)
     printf("OFF\n");
   else
     printf("ON\n");
+#endif
 }
 
 /**
  * Print details of whether time stamping is on - RFC 1323 related.
- *
+ * web100 1 on, 0 off
+ * web10g 1 on, 2 selfDisabled, 3 peerDisabled
  * @param is_timestampenabled
  */
 void print_timestamping_RFC1323(int is_timestampenabled) {
   printf("RFC 1323 Time Stamping: ");
+#if USE_TCPE
+  if (is_timestampenabled == 1)
+    printf("ON\n");
+  else if (is_timestampenabled == 2)
+    printf("OFF (self)\n");
+  else if (is_timestampenabled == 3)
+    printf("OFF (peer)\n");
+  else
+    printf("<undefined (%d)>\n", is_timestampenabled);
+#elif USE_WEB100
   if (is_timestampenabled == 0)
     printf("OFF\n");
   else
     printf("ON\n");
+#endif
 }
 
 /**
diff --git a/src/test_s2c_srv.c b/src/test_s2c_srv.c
index a297cf1..ee6b0fa 100644
--- a/src/test_s2c_srv.c
+++ b/src/test_s2c_srv.c
@@ -25,7 +25,7 @@
 extern pthread_mutex_t mainmutex;
 extern pthread_cond_t maincond;
 
-// used to store file descriptors of pipes created for ndttrace for C2S tests
+// used to store file descriptors of pipes created for ndttrace for S2C tests
 int mon_pipe2[2];
 
 /**
@@ -46,7 +46,7 @@ int mon_pipe2[2];
  * @param testOptions - the test options
  * @param conn_options - the connection options
  * @param testOptions Test options
- * @param s2cspd In-out parameter to store C2S throughput value
+ * @param s2cspd In-out parameter to store S2C throughput value
  * @param set_buff enable setting TCP send/recv buffer size to be used (seems unused in file)
  * @param window value of TCP send/rcv buffer size intended to be used.
  * @param autotune autotuning option. Deprecated.
@@ -70,10 +70,25 @@ int mon_pipe2[2];
  *				-102   - Retries exceeded while waiting for data from connected client
  *  			-errno - Other specific socket error numbers
  */
-int test_s2c(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_s2c(int ctlsockfd, tcp_stat_agent* agent, TestOptions* testOptions,
              int conn_options, double* s2cspd, int set_buff, int window,
              int autotune, char* device, Options* options, char spds[4][256],
              int* spd_index, int count_vars, CwndPeaks* peaks) {
+#if USE_WEB100
+  /* experimental code to capture and log multiple copies of the
+   * web100 variables using the web100_snap() & log() functions.
+   */
+  web100_snapshot* tsnap = NULL;
+  web100_snapshot* rsnap = NULL;
+  web100_group* tgroup;
+  web100_group* rgroup;
+  web100_var* var;
+#elif USE_TCPE
+  tcpe_data* snap;
+#endif
+  tcp_stat_connection conn;
+  /* Just a holder for web10g */
+  tcp_stat_group* group = NULL;
   int ret;  // ctrl protocol read/write return status
   int j, k, n;
   int xmitsfd;  // transmit (i.e server) socket fd
@@ -101,16 +116,6 @@ int test_s2c(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
   int sndqueue;
   struct sigaction new, old;
 
-  /* experimental code to capture and log multiple copies of the
-   * web100 variables using the web100_snap() & log() functions.
-   */
-  web100_snapshot* tsnap = NULL;
-  web100_snapshot* rsnap = NULL;
-  web100_group* group;
-  web100_group* tgroup;
-  web100_group* rgroup;
-  web100_connection* conn;
-  web100_var* var;
   pthread_t workerThreadId;
   int nextseqtosend = 0, lastunackedseq = 0;
   int drainingqueuecount = 0, bufctlrnewdata = 0;
@@ -124,7 +129,9 @@ int test_s2c(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
 
   SnapArgs snapArgs;
   snapArgs.snap = NULL;
+#if USE_WEB100
   snapArgs.log = NULL;
+#endif
   snapArgs.delay = options->snapDelay;
   wait_sig = 0;
 
@@ -224,7 +231,7 @@ int test_s2c(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
 
     clilen = sizeof(cli_addr);
     FD_ZERO(&rfd);
-    FD_SET(testOptions->c2ssockfd, &rfd);
+    FD_SET(testOptions->s2csockfd, &rfd);
     sel_tv.tv_sec = 5;  // wait for 5 secs
     sel_tv.tv_usec = 0;
     for (j = 0; j < RETRY_COUNT; j++) {
@@ -276,7 +283,7 @@ ximfd: xmitsfd = accept(testOptions->s2csockfd,
        }
     }
     src_addr = I2AddrByLocalSockFD(get_errhandle(), xmitsfd, 0);
-    conn = web100_connection_from_socket(agent, xmitsfd);
+    conn = tcp_stat_connection_from_socket(agent, xmitsfd);
 
     // set up packet capture. The data collected is used for bottleneck link
     // calculations
@@ -340,10 +347,15 @@ ximfd: xmitsfd = accept(testOptions->s2csockfd,
         // system("/sbin/sysctl -w net.ipv4.route.flush=1");
         system("echo 1 > /proc/sys/net/ipv4/route/flush");
       }
+
+#if USE_WEB100
       rgroup = web100_group_find(agent, "read");
       rsnap = web100_snapshot_alloc(rgroup, conn);
       tgroup = web100_group_find(agent, "tune");
       tsnap = web100_snapshot_alloc(tgroup, conn);
+#elif USE_TCPE
+      tcpe_data_new(&snap);
+#endif
 
       // fill send buffer with random printable data for throughput test
       bytes_written = 0;
@@ -394,6 +406,7 @@ ximfd: xmitsfd = accept(testOptions->s2csockfd,
 
           // get details of next sequence # to be sent and fetch value from
           // snap file
+#if USE_WEB100
           web100_agent_find_var_and_group(agent, "SndNxt", &group,
                                           &var);
           web100_snap_read(var, snapArgs.snap, tmpstr);
@@ -407,6 +420,13 @@ ximfd: xmitsfd = accept(testOptions->s2csockfd,
           lastunackedseq = atoi(
               web100_value_to_text(web100_get_var_type(var),
                                    tmpstr));
+#elif USE_TCPE
+          struct tcpe_val value;
+          web10g_find_val(snapArgs.snap, "SndNxt", &value);
+          nextseqtosend = value.uv32;
+          web10g_find_val(snapArgs.snap, "SndUna", &value);
+          lastunackedseq = value.uv32;
+#endif
           pthread_mutex_unlock(&mainmutex);
 
           // Temporarily stop sending data if you sense that the buffer is
@@ -463,8 +483,12 @@ ximfd: xmitsfd = accept(testOptions->s2csockfd,
                     "S2C test - failed to send test message to pid=%d",
                     s2c_childpid);
 
+#if USE_WEB100
       web100_snap(rsnap);
       web100_snap(tsnap);
+#elif USE_TCPE
+      tcpe_read_vars(snap, conn, agent);
+#endif
 
       log_println(1, "sent %d bytes to client in %0.2f seconds",
                   (int) bytes_written, tx_duration);
@@ -546,12 +570,18 @@ ximfd: xmitsfd = accept(testOptions->s2csockfd,
     // Get web100 variables from snapshot taken earlier and send to client
     log_println(6, "S2C-Send web100 data vars to client pid=%d",
                 s2c_childpid);
+
+#if USE_WEB100
     // send web100 data to client
-    ret = web100_get_data(tsnap, ctlsockfd, agent, count_vars);
+    ret = tcp_stat_get_data(tsnap, xmitsfd, ctlsockfd, agent, count_vars);
     web100_snapshot_free(tsnap);
     // send tuning-related web100 data collected to client
-    ret = web100_get_data(rsnap, ctlsockfd, agent, count_vars);
+    ret = tcp_stat_get_data(rsnap, xmitsfd, ctlsockfd, agent, count_vars);
     web100_snapshot_free(rsnap);
+#elif USE_TCPE
+    ret = tcp_stat_get_data(snap, xmitsfd, ctlsockfd, agent, count_vars);
+    tcpe_data_free(&snap);
+#endif
 
     // If sending web100 variables above failed, indicate to client
     if (ret < 0) {
